import React from "react";
import { MdOutlineSave } from "react-icons/md";
import { useEffect } from "react";

const FileInput = ({ fileAdd, file, setFile, setText, text }) => {
  useEffect(() => {
    getText(file);
  }, [file]);

  function getEnding(file) {
    var splited = file.name.split(".");
    return splited[splited.length - 1];
  }

  const handleFileSubmit = () => {
    if (file == null) {
      return;
    }
    var ending = getEnding(file);
    var xml = false;
    switch (ending) {
      case "xml":
        xml = true;
        break;
      case "jsgf":
        xml = false;
        break;
      default:
        alert("unknown file type");
        return;
    }
    fileAdd(text, xml);
  };
  const changeFileInput = async (e) => {
    setFile(e.target.files[0]);
  };
  const getText = async (fil) => {
    if (fil != null) {
      var ending = getEnding(fil);
      if (!(ending == "jsgf" || ending == "xml")) {
        setText("invalid file type");
        return;
      }
      var textPro = await fil.text();
      setText(textPro);
      return;
    }
    setText("");
  };
  return (
    <form onSubmit={handleFileSubmit}>
      <p>
        <input type="file" onChange={changeFileInput} />
        <MdOutlineSave onClick={handleFileSubmit} />
      </p>
      <textarea
        onChange={(e) => setText(e.target.value)}
        rows="4"
        cols="50"
        value={text}
      />
    </form>
  );
};

export default FileInput;
